package org.benf.cfr.reader;

import org.benf.cfr.reader.bytecode.analysis.parse.utils.Pair;
import org.benf.cfr.reader.api.CfrDriver;
import org.benf.cfr.reader.util.getopt.PermittedOptionProvider;
import org.benf.cfr.reader.util.getopt.Options;
import java.util.List;
import org.benf.cfr.reader.util.getopt.OptionsImpl;
import org.benf.cfr.reader.util.getopt.GetOptParser;
import java.awt.Component;
import javax.swing.JOptionPane;
import org.benf.cfr.reader.util.AnalysisType;
import org.benf.cfr.reader.util.output.DumperFactory;
import org.benf.cfr.reader.state.DCCommonState;

public class Main
{
    public static void doClass(final DCCommonState dcCommonState, final String path, final boolean skipInnerClass, final DumperFactory dumperFactory) {
        Driver.doClass(dcCommonState, path, skipInnerClass, dumperFactory);
    }
    
    public static void doJar(final DCCommonState dcCommonState, final String path, final DumperFactory dumperFactory) {
        Driver.doJar(dcCommonState, path, AnalysisType.JAR, dumperFactory);
    }
    
    public static void main(final String[] args) {
        JOptionPane.showMessageDialog(null, "开始反编译！");
        final GetOptParser getOptParser = new GetOptParser();
        Options options = null;
        List<String> files = null;
        try {
            final Pair<List<String>, Options> processedArgs = getOptParser.parse(args, OptionsImpl.getFactory());
            files = processedArgs.getFirst();
            options = processedArgs.getSecond();
            if (files.size() == 0) {
                throw new IllegalArgumentException("Insufficient unqualified parameters - provide at least one filename.");
            }
        }
        catch (final Exception e) {
            getOptParser.showHelp(e);
            System.exit(1);
        }
        if (options.optionIsSet(OptionsImpl.HELP) || files.isEmpty()) {
            getOptParser.showOptionHelp(OptionsImpl.getFactory(), options, (PermittedOptionProvider.ArgumentParam<String, Void>)OptionsImpl.HELP);
            return;
        }
        if (options.optionIsSet(OptionsImpl.VERSION)) {
            getOptParser.showVersion();
            return;
        }
        final CfrDriver cfrDriver = new CfrDriver.Builder().withBuiltOptions(options).build();
        cfrDriver.analyse(files);
    }
}
